routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return view('welcome');
});

Auth::routes();

Route::get('/home', 'HomeController@index')->name('home');


Route::prefix('/news')->group(function () {
    Route::name('posts.')->group(function() {
        Route::get('', ['as'=>'list', 'uses' => 'PostController@index']);
        Route::middleware(['auth'])->group(function () {
            Route::post('', ['as'=>'store', 'uses' => 'PostController@store']);
            Route::get('/create', ['as'=>'create', 'uses' => 'PostController@create']);
            Route::get('/{post}/delete', ['as'=>'delete', 'uses' => 'PostController@destroy']);
            Route::get('/{post}/edit', ['as'=>'edit', 'uses' => 'PostController@edit']);
            Route::post('/{post}', ['as'=>'update', 'uses' => 'PostController@update']);
        });
        Route::get('/{post}', ['as'=>'show', 'uses' => 'PostController@show']);
    });
});

app/Post.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;
use Illuminate\Http\UploadedFile;

/**
 * Class Post
 * @package App
 * @property integer id Идентификатор поста
 * @property string content Тело поста
 * @property string title Заголовок поста
 * @property string image Имя изображения
 * @property integer user_id Заголовок поста
 */
class Post extends Model
{
    public static $DEFAULT_IMAGES_FOLDER = 'storage/images/';

    protected $fillable = [
        'title', 'content', 'image', 'user_id'
    ];

    public function createdBy()
    {
        return $this->belongsTo(User::class, 'user_id');
    }

    public function categories()
    {
        return $this->belongsToMany(PostCategory::class);
    }

    public function getImageUrlAttribute()
    {
        return asset($this::$DEFAULT_IMAGES_FOLDER . $this->image);
    }

    public function deleteImage()
    {
        if(!is_null($this->image) && $this->image != '') {
            $imagePath = public_path($this::$DEFAULT_IMAGES_FOLDER) . $this->image;
            if(file_exists($imagePath))
                unlink($imagePath);
        }
    }

    public function handleImage(UploadedFile $imageFile)
    {
        if(!is_null($this->image) && $this->image !== '') {
            $this->deleteImage();
        }

        $imagename = time().'.'.$imageFile->getClientOriginalExtension();
        $destinationPath = public_path($this::$DEFAULT_IMAGES_FOLDER);
        $imageFile->move($destinationPath, $imagename);

        $this->image = $imagename;
    }

    public function delete()
    {
        $ret = parent::delete();
        $this->deleteImage();
        return $ret; // TODO: Change the autogenerated stub
    }

    public function scopeCategory($query, $id)
    {
        return $query->whereHas('categories', function($q) use ($id) {
           $q->where('id', $id);
        });
    }
}

app/Http/Controllers/PostController.php
<?php

namespace App\Http\Controllers;

use App\Post;
use App\PostCategory;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Auth;

class PostController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index(Request $request)
    {
        $category_id = $request->query('category', '');
        if($category_id != '') {
            $posts = Post::category($category_id)->orderBy('created_at', 'desc');
        } else {
            $posts = Post::orderBy('created_at', 'desc');
        }

        $posts = $posts->paginate(5)
            ->appends($request->except('page'));
        return view('posts.list', compact('posts'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create(Request $request)
    {
        $categories = PostCategory::all();
        return view('posts.create', compact('categories', 'request'));
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        $this->validate($request, [
            'image' => 'image|mimes:jpeg,png,jpg,gif,svg',
            'title' => 'required|min:5',
            'content' => 'required|min:20',
        ]);

        $post = new Post();

        if($request->hasFile('image')) {
            $image = $request->file('image');
            $post->handleImage($image);
        }

        $post->user_id = Auth::user()->id;
        $post->fill($request->input());
        $post->save();

        $category_ids = $request->input('categories');
        $post->categories()->attach($category_ids);

        $new_categories = explode(",", $request->input('new_categories', ''));
        foreach ($new_categories as $new_category) {
            $post_category = new PostCategory();
            $post_category->name = trim($new_category);
            if($post_category->name !== '') {
                $post_category->save();
                $post_category->posts()->attach($post->id);
            }
        }


        return redirect(route('posts.show', ['id' => $post->id]));
    }

    /**
     * Display the specified resource.
     *
     * @param  \App\Post  $post
     * @return \Illuminate\Http\Response
     */
    public function show(Post $post)
    {
       return view('posts.show', compact('post'));
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  \App\Post  $post
     * @return \Illuminate\Http\Response
     */
    public function edit(Post $post, Request $request)
    {
        $categories = PostCategory::all();
        $post_categories = $post->categories()->get();
        return view('posts.create', compact('post', 'categories', 'post_categories', 'request'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \App\Post  $post
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, Post $post)
    {
        $this->validate($request, [
            'image' => 'image|mimes:jpeg,png,jpg,gif,svg',
            'title' => 'required|min:5',
            'content' => 'required|min:20',
        ]);

        if($request->hasFile('image')) {
            $imageFile = $request->file('image');
            $post->handleImage($imageFile);
        }

        $post->user_id = Auth::user()->id;
        $post->fill($request->input());
        $post->save();

        $category_ids = $request->input('categories');
        $post->categories()->detach($category_ids);
        $post->categories()->attach($category_ids);

        $new_categories = explode(",", $request->input('new_categories', ''));
        foreach ($new_categories as $new_category) {
            $post_category = new PostCategory();
            $post_category->name = trim($new_category);
            if($post_category->name !== '') {
                $post_category->save();
                $post_category->posts()->attach($post->id);
            }
        }

        return redirect(route('posts.show', ['id' => $post->id]));
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  \App\Post  $post
     * @return \Illuminate\Http\Response
     */
    public function destroy(Post $post)
    {
        $post->delete();
        return redirect(route('posts.list'));
    }
}

resources/views/posts/create.blade.php
@extends('layouts.app')

@section('content')
<div class="row">
    <div class="col-md-12">
        @if ($errors->any())
            <div class="alert alert-danger">
                <strong>Whoops!</strong> There were some problems with your input.<br><br>
                <ul>
                    @foreach ($errors->all() as $error)
                        <li>{{ $error }}</li>
                    @endforeach
                </ul>
            </div>
        @endif
    </div>
</div>
<div class="row">
    <div class="col-md-12">
        @php
        $route = 'posts.store';
        if(isset($post)) {
            $route = ['posts.update', $post->id];
        } else {
            $post = (object) array(
                'title' => '',
                'content' => '',
            );
        }
        @endphp
        {{Form::open(['route' => $route, 'files' => true])}}
        <div class="row">
            <div class="col-md-6">
                <div class="row">
                    <div class="col-md-12">
                        <div class="input-group">
                            {{Form::label('title', 'Title',['class' => 'control-label', 'required' => true ])}}
                            {{Form::input('text', 'title', $request->old('title', $post->title), ['class' => 'form-control'])}}
                        </div>
                    </div>
                </div>
                <div class="row">
                    <div class="col-md-12">
                        <div class="input-group">
                            {{Form::label('content', 'Content',['class' => 'control-label'])}}
                            {{Form::textarea('content' , $request->old('content', $post->content), ['class' => 'form-control', 'required' => true ])}}
                        </div>
                    </div>
                </div>
                <div class="row">
                    <div class="col-md-12">
                        <div class="input-group">
                            {{Form::label('image', 'Preview',['class' => 'control-label'])}}
                            {{Form::file('image')}}
                        </div>
                    </div>
                </div>
                <div class="row">
                    <div class="col-md-12">
                        <br>
                        {{Form::submit('Save', ['class' => 'btn btn-success'])}}
                    </div>
                </div>
            </div>
            <div class="col-md-6">
                <div class="row">
                    <div class="col-md-12">
                        @php
                            $old_categories = $request->old('categories');
                        @endphp
                        <select multiple="multiple" id="my-select" name="categories[]">
                            @foreach($categories as $category)
                                <option
                                        value="{{$category->id}}"
                                        @php
                                        $found = false;
                                        if(isset($old_categories)) {
                                            if(in_array($category->id, $old_categories))
                                                $found = true;
                                        } elseif(isset($post_categories)) {
                                            foreach($post_categories as $e) {
                                                if($e->id == $category->id) {
                                                    $found = true;
                                                    break;
                                                }
                                            }
                                        }
                                        if ($found) echo 'selected';
                                    @endphp
                            >{{$category->name}}</option>
                        @endforeach
                        </select>
                    </div>
                </div>
                <div class="row">
                    <div class="col-md-12">
                        <p style="margin-top: 20px">Apply additional categories (separated by comma):</p>
                        <input type="text" name="new_categories" value="{{$request->old('new_categories')}}">
                    </div>
                </div>
            </div>
        </div>
        {{Form::close()}}
    </div>
</div>
@endsection

@push('scripts')
    <script>
        $('#my-select').multiSelect({
            selectableHeader: "<div class='text-center' style='background-color: #ececec; border-radius: 5px 5px 0 0;'>Available categories</div>",
            selectionHeader: "<div class='text-center' style='background-color: #ececec; border-radius: 5px 5px 0 0;'>Applied categories</div>",
        });
    </script>
@endpush

resources/views/posts/list.blade.php
@extends('layouts.app')

@section('content')
<div class="row">
    <div class="col-md-12 text-center">
        {{$posts->links()}}
    </div>
</div>
<div class="row">
    <div class="col-md-8 col-md-offset-2">
        <div class="panel panel-default">
            <div class="panel-heading">Recent posts</div>

            <ul class="list-group">
                @forelse($posts as $post)
                    <li class="list-group-item">
                        @include('posts.post-for-list', ['post' => $post])
                    </li>
                @empty
                    <li class="list-group-item">
                        <p>No posts :(</p>
                    </li>
                @endforelse
            </ul>
        </div>
    </div>
</div>
<div class="row">
    <div class="col-md-12 text-center">
        {{$posts->links()}}
    </div>
</div>
@endsection

resources/views/posts/post-for-list.blade.php
<h2><a href="{{route('posts.show', ['id' => $post->id])}}" style="color: black;">{{$post->title}}</a></h2>
<p>
    @foreach($post->categories as $category)
        <a href="{{route('posts.list')}}?category={{$category->id}}" class="badge">{{$category->name}}</a>
    @endforeach
</p>
<br>
@if($post->image)
    <img src="{{$post->image_url}}" alt="Post preview image" style="max-width: 250px;">
    <br><br>
@endif
<p>{{$post->createdBy->name}} wrote it {{$post->created_at->diffForHumans()}}</p>

resources/views/posts/show.blade.php
@extends('layouts.app')

@section('content')
    @auth
    <div class="row">
        <div class="col-md-12">
            <a href="{{route('posts.delete', ['id' => $post->id])}}" class="btn btn-danger">Delete this post</a>
            <a href="{{route('posts.edit', ['id' => $post->id])}}" class="btn btn-primary">Edit this post</a>
        </div>
    </div>
    @endauth
    <div class="row">
        <div class="col-md-12">
            <h3>{{$post->title}}</h3>
        </div>
    </div>
    <div class="row">
        <div class="col-md-12">
            <p>
                @foreach($post->categories as $category)
                    <a href="{{route('posts.list')}}?category={{$category->id}}" class="badge">{{$category->name}}</a>
                @endforeach
            </p>
        </div>
    </div>
    <hr style="border-color: #9c9c9c;">
    @if($post->image)
        <div class="row">
            <div class="col-md-12">
                <img src="{{$post->image_url}}" alt="Post image" style="max-width: 500px;">
            </div>
        </div>
    @endif
    <div class="row" style="padding-top: 50px">
        <div class="col-md-12">
            <p style="font-size: 18px">
                {!!nl2br(htmlspecialchars($post->content))!!}
            </p>
        </div>
    </div>
@endsection